var tf = tf || {};
(function($) {
    $(document).ready(function() {

        if ($('#scrollHere').length) {
            var top = $('#scrollHere').offset().top;
            $('html,body').scrollTop(top);
        }

        $.fn.equalHeight = function() {
            var tallest = 0;
            this.each(function() {
                var h = $(this).height();
                tallest = h > tallest ? h : tallest;
            });
            this.height(tallest);
            return this;
        };

        $.fn.tabs = function() {
            return this.each(function() {
                new Tab(this);
            });
        };

        var Tab = function(elem) {
            this.element = $(elem);
            this.init();
        };

        Tab.prototype = {
            init: function() {
                var that = this;
                this.element.find('a.jslink').click(function() {
                    that.handle.apply(that, arguments);
                    return false;
                });


                $(document).bind('togglepanels', function(e, o) {
                    if ($(o.target).parent().get(0) === that.element.get(0)) {
                        if (that.element.hasClass('off')) {
                            o.callback(true);
                            that.element.css('borderBottom', '')
                                    .removeClass('off').find('.tabsPanel').eq(0).removeClass('hide');
                        } else {
                            o.callback(false);
                            that.element.css('borderBottom', 'solid 8px #9E9E9E')
                                    .addClass('off').find('.tabsPanel').addClass('hide');
                        }
                    }
                });

                if (window.location.hash != "") {
                    tab = window.location.hash.substring(1);
                    this.element.find('.tabsNav a[href$=' + tab + ']').click();
                }
            },

            handle: function(e) {
                var id = e.target.href.match(/\?tab=(\w+)/)
                if (id == null) id = e.target.href.match(/\#(\w+)/)
                if (id == null) return;
                id = id.pop();
                window.location.hash = id;
                that = this;

                var panel = this.element.find('#' + id + 'Panel');
                that.element.find('.tabsNav li').removeClass('active');
                that.element.find('#' + id + 'Tab').addClass('active');
                that.element.find('.tabsPanel').addClass('hide');
                panel.removeClass('hide');
//
//                var finishFunction = function() {
//                    that.element.find('.tabsNav li').removeClass('active');
//                    that.element.find('#'+id+'Tab').addClass('active');
//                    that.element.find('.tabsPanel').addClass('hide');
//                    panel.removeClass('hide');
//
//                    jqueryFulltext();
//
//                    scrollToTabs();
//                };
//
//                var nonWhite = panel.html().replace(/\s+/g,'').length;
//                if (nonWhite < 1) {
//                    $(".loading").removeClass('hide');
//                    $.ajax({
//                        type: "GET",
//                        url: e.target.href,
//                        complete: function(xhr,status) {
//                            panel.html(xhr.responseText);
//                            finishFunction();
//                            $(".loading").addClass('hide');
//                        }
//                    });
//
//                } else {
//                    finishFunction();
//                }
//                return false;
            }
        };

        function scrollToTabs() {
            var top = $('#tabModule').offset().top;
            $('html,body').animate({scrollTop:top}, 300);
        }

        $.fn.accordian = function() {
            return this.each(function() {
                new Accordian(this);
            });
        };

        var Accordian = function(elem) {
            this.element = $(elem);
            this.init();
        };

        Accordian.prototype = {
            init: function() {
                var that = this;
                this.element.find('.accordianPanel').addClass('hide');
                this.element.find('.accordianHeader')
                        .removeClass('active').click(function() {
                    that.handle.apply(that, arguments);
                    return false;
                });
            },

            handle: function(e) {
                var el = $(e.currentTarget).next();
                //if (el.find("a").attr("href") != "#" && !el.hasClass("hide")) return;
                this.element.find('.accordianHeader').removeClass('active');
                $('.accordianPanel').removeClass('.active');
                if (el.hasClass('hide')) {
                    el.removeClass('hide');
                    el.removeClass('noscript');
                    $(e.currentTarget).addClass('active')
                } else {
                    el.addClass('hide');
                    el.addClass('noscript');
                    $(e.currentTarget).removeClass('active')
                }
            }
        };

        $('.tabsTrigger').click(function() {
            var that = this;
            $(document).trigger('togglepanels', {
                target: this, callback: function(active) {
                    if (active) {
                        $(that).addClass('tabsTriggerActive');
                    } else {
                        $(that).removeClass('tabsTriggerActive');
                    }
                }
            });
            return false;
        });


        $('.details h4').removeClass('active').click(
                                                    function() {
                                                        var el = $(this);
                                                        if (el.hasClass('active')) {
                                                            el.removeClass('active').next().hide();
                                                        } else {
                                                            el.addClass('active').next().show();
                                                        }
                                                        return false;
                                                    }).next().hide();

        /*
         Hint plug-in;

         <div class="hint">
         <p><span>2. </span>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam.</p>
         <p><a href="#">More information</a></p>
         </div>
         */
        $('<div id="hint" class="hide">\
                <div class="bd"></div>\
                <div class="ft"></div>\
            </div>').appendTo('body');

        $.fn.hint = function() {
            return this.each(function() {
                new Hint(this);
            });
        };

        $.fn.hint.getContent = function(el) {
//            if (!$(el).hasClass('notProofed')) {
//                el = $(el).parents('.notProofed');
//            }
//            el = $(el).next('.hiddenhint');
//            return $(el).html();
            return "";
        };

        var Hint = function(elem) {
            this.element = $(elem);
            this.init();
        };

        Hint.prototype = {
            init: function() {
                var that = this;
                $('.hint')
                        .mouseenter(function(e) {
                    var xy = that.getXY.call(that, e);
                    $('#hint').css({'top': xy[1] + 'px', 'left': (xy[0] - 40) + 'px'})
                            .removeClass('hide').find('.bd').html($.fn.hint.getContent(e.target));
                })
                        .mouseleave(function(e) {
                    $('#hint').css('top', '')
                            .addClass('hide').find('.bd').empty();
                });
            },

            getXY: function(e) {
                return [
                    $(document).scrollLeft() + (e.clientX - 20),
                    $(document).scrollTop() + (e.clientY + 10) ];
            }
        };

        $('.hint').css({'borderBottom': '1px dotted', 'cursor': 'pointer'}).hint();


        $.fn.dropDown = function() {
            return this.each(function(i) {
                new DropDown(this, i);
            });
        };

        var DropDown = function(el, i) {
            var that = this;

            this.element = $(el);
            this.indx = i;
            //this.element.next(".dropDown").hide();

            this.element.click(function() {
                that.handle.apply(that, arguments);
                return false;
            });
        };

        var openDropdown = null;
        DropDown.prototype = {
            handle: function(e) {
                if (this.element.hasClass('active')) {
                    this.close(e);
                } else {
                    this.open(e);
                }
                e.stopImmediatePropagation();
            },

            open: function(e) {
                if (openDropdown != null) {
                    openDropdown.close.apply(openDropdown);
                }
                var that = this;
                this.element.addClass('active');
                this.element.parent().css('zIndex', 10);
                this.element.next().css({'zIndex': 16000}).css("display","block");
                openDropdown = this;
                $(document).click(function() {
                    that.close.apply(that, arguments);
                    return true;
                })
                    .keyup(function(e){
                        if (e.keyCode == 27) {
                            that.close.apply(that, arguments);
                            return true;
                        }
                    });
            },

            close: function(e) {
                this.element.removeClass('active');
                this.element.parent().css('zIndex', 0);
                this.element.next().css("display","none");
                $(document).unbind('click');
                openDropdown = null;
            }
        };


        $.fn.showPreview = function() {
            var that = this;
            this.click(function() {
                $('#preview').removeClass('hide');
                $('#preview').css('position', 'relative');

                if (!$('#fpi').find("img").length) {
                    var img = $("<img alt='First page Image'>").attr("src",that.attr('href'));
                    $('#fpi').append(img);
                }

                window.location.hash = "#preview";
                return false;
            });
            if (window.location.hash == '#preview') {
                this.click();
            }
            $('#preview .close a').click(function() {
                $('#preview').addClass('hide');
                $('#preview').css('position', 'absolute');
                window.location.hash = "";
                $('html, body').scrollTop();
                return false;
            });
        };

        //Section: Zooming of first page preview
        var zoomstate = false;
        unzoom();

        $('#preview .figure a').click(function() {
            if (zoomstate) {
                unzoom();
            } else {
                zoom();
            }
            return false;
        });

        //add size link functionality
        function unzoom() {
            zoomstate = false;
            var zoomlink = $('#preview .caption a.zoom');
            var unzoomlink = $('#preview .caption a.unzoom');
            zoomlink.removeClass('hide');
            unzoomlink.addClass('hide');
            var parentWidth = $('#preview').parent().css('width');
            $('#preview').css('width', parentWidth);
            $('#fpi img').css('width', '500px');
        }

        function zoom() {
            zoomstate = true;
            var zoomlink = $('#preview .caption a.zoom');
            var unzoomlink = $('#preview .caption a.unzoom');
            zoomlink.addClass('hide');
            unzoomlink.removeClass('hide');
            $('#preview').css('width', '798px');
            $('#fpi img').css('width', '700px');
        }

        //End Section: Zooming of first page preview


        $('.recommendations .description').equalHeight();
        $('.secondaryAudience .gutter').equalHeight();
        $('.promotions .unit').equalHeight();

        var active = $('#secondaryNav .accordianHeader.active a').eq(0);
        $('.accordian').accordian();
        active.click();
        $('.dropDownLabel').dropDown();

        $('a.preview').showPreview();

        $('.jqueryTab').tabs();
        jqueryFulltext();


        if ($('.hasAbstract').length && window.location.hash != "#preview") {
            $('#preview').addClass('hide');
            $('#preview').css('position', 'absolute');
            $('a.preview').removeClass('hide');
        }
    });

})(jQuery, tf);

function debug(str) {
    if ($('#debug').length) {
        $('#debug').append(str + "<br>");
    } else {
        $('body').append("<div id='debug'>" + str + "<br></div>");
    }
}

function doPop(w, h, url) {
    if (w > screen.width) w = screen.width; // do not make it bigger than the screen
    if (h > screen.height) h = screen.height;

    window.open(url, 'popup', 'toolbar=1,scrollbars=1,location=1,statusbar=0,menubar=0,resizable=1,width=' + w + ',height=' + h);

}

function jqueryFulltext() {
    //THESE ARE THE JQUERY PIECES FOR THE FULLTEXT
    panel = $('#fulltextPanel');
    panel.find('.dropDownLabel').dropDown();
    /*summationNavigation sub naviagtion*/
    panel.find('.summationNavigation').bind('mouseenter mouseleave', function() {
        $(this).find('ul').toggleClass('entered');
        $(this).toggleClass('elevate');
    });

    jQuery("a.popup").click(function() {
        var url = jQuery(this).attr('href');
        var w = 768;
        var h = 578;

        if (jQuery(this).figDimension) {
            var d = jQuery(this).figDimension;
            if (d.w) w = d.w + 230; // add sidebar width and some padding
            if (d.h) h = d.h + 280; // add top navigation an some space for captipn
        }

        doPop(w, h, url);
        return false;
    });

    jQuery("a.ref").click(function() {
        var url = jQuery(this).attr('href');
        if (url.indexOf("javascript") === 0) { //allow javascript links to execute
            return true;
        }
        var w = 700;
        var h = 500;

        doPop(w, h, url);
        return false;
    });
    //                    END JQUERY FOR FULLTEXT
}

